/*
ID: espr1t
TASK: SuperMario
KEYWORDS: Hard, DP, Inner Cycle Optimization
*/

#include <cstdio>
#include <queue>

using namespace std;
const int MAX = 10000004;

int n, k;
long long a[MAX];

int main(void) {
    int F, A, B, M;
    fscanf(stdin, "%d %d", &n, &k);
    fscanf(stdin, "%d %d %d %d", &F, &A, &B, &M);
    a[1] = F;
    for (int i = 2; i <= n; i++)
        a[i] = (a[i - 1] * A + B) % M;

    deque < pair <long long, int> > q(1, make_pair(0, n + 1));
    for (int i = n; i >= 0; i--) {
        while (!q.empty() && q.front().second > i + k)
            q.pop_front();
        long long price = a[i] + q.front().first;
        while (!q.empty() && q.back().first >= price)
            q.pop_back();
        q.push_back(make_pair(price, i));
    }
    fprintf(stdout, "%lld\n", q.back().first);
    return 0;
}
