/*
ID: espr1t
TASK: SuperMario
KEYWORDS: Medium, DP, Inner Cycle Optimization
*/

#include <cstdio>
#include <algorithm>

using namespace std;
FILE* in = stdin; FILE* out = stdout;

const int MAX = 10000004;
const int TREE = 2097152;
const long long INF = 1000000000000000001LL;

int n, k;
long long a[MAX];

long long tree[TREE];
void update(int idx, long long val) {
    idx += (TREE >> 1);
    tree[idx] = val; idx >>= 1;
    while (idx) {
        long long nval = min(tree[(idx << 1) | 0], tree[(idx << 1) | 1]);
        if (tree[idx] == nval)
            break;
        tree[idx] = nval, idx >>= 1;
    }
}

int main(void) {
//    in = fopen("SuperMario.in", "rt");
    
    int n, k;
    int F, A, B, M;
    fscanf(in, "%d %d", &n, &k);
    fscanf(in, "%d %d %d %d", &F, &A, &B, &M);

    long long ans = INF;
    for (int i = 0; i < TREE; i++)
        tree[i] = INF;
    update(k - 1, 0);
    for (int i = 0; i < n; i++) {
        long long cur = F + tree[1];
        F = (int)(((long long)F * A + B) % M);
        update(i % k, cur);
        if (i + k >= n)
            ans = min(ans, cur);
    }
    fprintf(out, "%lld\n", k > n ? 0LL : ans);
    return 0;
}
